OPTION _EXPLICIT
_TITLE "Word Search v1" ' for QB64 B+ started 2018-10-20

' The goal is to make a generic Word Search Puzzle handler.
' part 1: handle a newspaper style Word Search puzzle from 2 text files
'         name letters.txt
'         name words.txt
' So the Thanksgiving puzzle (20 x 20 letter grid and 36 words to find) has 2 files,
' Thanksgiving letters.txt and Thankgiving words.txt.
'
' When the Letters file is loaded the number of rows and cols the letter grid is determined.
' There is a limit of 40 letters across and 20 letters down for the letter block,
' but 20 letters or less across allows a space between letters in grid.
'
' For words list, the shared nWords variable is determined at file load time.
' There is a 48 word limit for search words  with a limit of 15 maybe 16 letter word length.
'
DIM SHARED FileBaseName$
FileBaseName$ = "BAT"
'FileBaseName$ = "TRICK TREAT"
'FileBaseName$ = "Thanksgiving"
'FileBaseName$ = "Finance" 'fresh out of PD 2018-10-16  Tues
'FileBaseName$ = "NewAgeAltCare" 'fresh out of PD 2018-10-18  Thurs

DIM SHARED Cols AS INTEGER, Rows AS INTEGER, Nwords AS INTEGER, Spacer AS INTEGER
REDIM SHARED L$(1 TO 1, 1 TO 1) 'for the letters grid these arrays need to be base 1
REDIM SHARED W$(1 TO 1) '        for the Words to fins list.

' directions starting due East = 1 clockwise to NE = 8
DIM SHARED DX(1 TO 8) AS INTEGER, DY(1 TO 8) AS INTEGER
DX(1) = 1: DY(1) = 0 '   E
DX(2) = 1: DY(2) = 1 '   SE
DX(3) = 0: DY(3) = 1 '   S
DX(4) = -1: DY(4) = 1 '  SW
DX(5) = -1: DY(5) = 0 '  W
DX(6) = -1: DY(6) = -1 ' NW
DX(7) = 0: DY(7) = -1 '  N
DX(8) = 1: DY(8) = -1 '  NE
DIM i AS INTEGER, wate$, nFound AS INTEGER, k$

' Main code
LoadLetters
ShowPuzzle
LoadWords
FOR i = 1 TO Nwords 'this time through find word, show word, display count found
    LOCATE Rows + 2, 1: PRINT SPACE$(40)
    LOCATE Rows + 2: PRINT W$(i);: INPUT "  press enter to show "; wate$
    nFound = showWord%(i)
    IF nFound THEN
        IF i > 24 THEN
            LOCATE i - 24, 61
        ELSE
            LOCATE i, 42
        END IF
        PRINT W$(i); nFound;
    END IF
NEXT
k$ = INKEY$ 'in case still pressing enter
WHILE LEN(k$): k$ = INKEY$: WEND
LOCATE Rows + 3, 1: PRINT "Word Search Finished"
_DELAY 1

FUNCTION showWord% (wIndex) 'the wIndex is the index to the word in the W$ list
    'First find a letter that matches the first letter in W$(wIndex),
    'then at that x,y try each of 8 directions to see if find a match.
    'See if enough room to fit the find word before heading out.

    DIM first$, lenFind AS INTEGER, x AS INTEGER, y AS INTEGER, d AS INTEGER, b1 AS INTEGER, b2 AS INTEGER
    DIM xx AS INTEGER, yy AS INTEGER, b$, i AS INTEGER, wCount AS INTEGER, wate$

    first$ = MID$(W$(wIndex), 1, 1): lenFind = LEN(W$(wIndex)) - 1
    FOR y = 1 TO Rows
        FOR x = 1 TO Cols
            IF L$(x, y) = first$ THEN
                FOR d = 1 TO 8 'will word fit in this direction? 2 booleans True condition
                    b1 = lenFind * DX(d) + x > 0 AND lenFind * DX(d) + x <= Cols
                    b2 = lenFind * DY(d) + y > 0 AND lenFind * DY(d) + y <= Rows
                    IF b1 AND b2 THEN 'word fits,
                        ' build word from Letters block to see if matches word to find
                        b$ = first$: xx = x + DX(d): yy = y + DY(d)
                        FOR i = 2 TO LEN(W$(wIndex))
                            b$ = b$ + L$(xx, yy)
                            xx = xx + DX(d): yy = yy + DY(d)
                        NEXT
                        xx = x: yy = y 'copy x, y for rebuilding word on screen
                        IF b$ = W$(wIndex) THEN 'found one show our result
                            ClearPuzzle
                            FOR i = 1 TO LEN(W$(wIndex))
                                LOCATE yy, Spacer * xx: PRINT L$(xx, yy);
                                xx = xx + DX(d): yy = yy + DY(d)
                            NEXT
                            LOCATE Rows + 2, 1: PRINT SPACE$(40)
                            LOCATE Rows + 2, 1: PRINT W$(wIndex);
                            INPUT "  OK, press enter "; wate$
                            wCount = wCount + 1
                            ShowPuzzle
                        END IF
                    END IF
                NEXT
            END IF
        NEXT
    NEXT
    showWord% = wCount
END FUNCTION

SUB ShowPuzzle
    DIM x AS INTEGER, y AS INTEGER, wate$
    LOCATE 1, 1
    FOR y = 1 TO Rows
        FOR x = 1 TO Cols
            IF Spacer = 1 THEN PRINT L$(x, y); ELSE PRINT L$(x, y); " ";
        NEXT
        PRINT
    NEXT
END SUB

SUB ClearPuzzle
    DIM y AS INTEGER
    FOR y = 1 TO Rows
        LOCATE y, 1
        PRINT SPACE$(Spacer * Cols)
    NEXT
END SUB

SUB LoadLetters
    ' FileBaseName$ is shared and set at beginning of this code
    ' set DIM Shared Rows and Cols for the rest of the app
    DIM fline$, i AS INTEGER
    IF _FILEEXISTS(FileBaseName$ + " Letters.txt") THEN
        OPEN FileBaseName$ + " Letters.txt" FOR INPUT AS #1
        DO UNTIL EOF(1)
            Rows = Rows + 1
            IF Rows > 20 THEN PRINT "Sorry, there is a 20 row limit to the Letters block, goodbye.": CLOSE #1: END
            LINE INPUT #1, fline$
            IF Rows = 1 THEN
                Cols = LEN(fline$)
                IF Cols > 20 THEN Spacer = 1 ELSE Spacer = 2
                IF Cols > 40 THEN PRINT "Sorry, the Letters block is too wide, goodbye.": CLOSE #1: END
            END IF
            REDIM _PRESERVE L$(1 TO Cols, 1 TO Rows)
            FOR i = 1 TO Cols
                L$(i, Rows) = MID$(fline$, i, 1)
            NEXT
        LOOP
        CLOSE #1
    ELSE
        PRINT "Sorry, can not find " + FileBaseName$ + " Letters.txt, goodbye."
        END
    END IF
END SUB

SUB LoadWords
    'FileBaseName$ is shared and set at beginning of this code
    'Nwords is Dim shared and set here
    DIM fline$
    Nwords = 0
    IF _FILEEXISTS(FileBaseName$ + " Words.txt") THEN
        OPEN FileBaseName$ + " Words.txt" FOR INPUT AS #1
        DO UNTIL EOF(1)
            LINE INPUT #1, fline$
            IF LEN(LTRIM$(RTRIM$(fline$))) > 2 THEN
                Nwords = Nwords + 1
                IF Nwords > 48 THEN PRINT "Sorry, there are too many words to display, goodbye.": CLOSE #1: END
                REDIM _PRESERVE W$(1 TO Nwords)
                W$(Nwords) = fline$
                IF Nwords > 24 THEN
                    LOCATE Nwords - 24, 61
                ELSE
                    LOCATE Nwords, 42
                END IF
                PRINT W$(Nwords);
            END IF
        LOOP
        CLOSE #1
    ELSE
        PRINT "Sorry, can not find " + FileBaseName$ + " Words.txt, goodbye."
        END
    END IF
END SUB
