OPTION _EXPLICIT
_TITLE "Word Search v2" ' for QB64 B+ started 2018-10-20 finished 2018-10-21

' The goal is to make a generic Word Search Puzzle handler.
' part 1: handle a newspaper style Word Search puzzle from 2 text files
'         BaseName Letters.txt
'         BaseName Words.txt
' So the Thanksgiving puzzle (20 x 20 letter grid and 36 words to find) has 2 files,
' Thanksgiving letters.txt and Thankgiving words.txt.
'
' When the Letters file is loaded SHARED Rows and Cols for the Letter grid is determined.
' There is a limit of 40 letters across and 20 letters down for the letter block,
' but 20 letters or less across allows a space between letters in grid.
'
' For words list, the SHARED Nwords variable is determined at file load time.
' There is a 48 word limit for search words with a limit of 13 letter word length.
'
' In v2, I am trying a 2nd method for finding words in the Letters block by makeing 4 arrays
' of strings for left / right, up / down, diagonal down and right / up and left, and
' diagonal up and right / down and left. The mirror direction strings are checked by reversing
' the string. With this setup, just run through the strings using INSTR to find matches.
' The tricky part is translating the string number and INSTR position back to the L$() array.

' v1 was 178 lines, this is 448 but includes both methods and better display and some debug code left in.

DIM SHARED FileBaseName$
'various files tested
FileBaseName$ = "BAT" '           For QB64 Halloween challenge, first ever count find word!!!!
'FileBaseName$ = "TRICK TREAT" '   30 cols x 20 rows crappy puzzle
'FileBaseName$ = "Thanksgiving" '  20 x 20 this was first puzzle ever attempted with Word Search Nov, 2016
'FileBaseName$ = "Finance" '       15 x 15 fresh out of newspaper, PD 2018-10-16  Tues
'FileBaseName$ = "NewAgeAltCare" ' 15 x 15 fresh out of newspaper, PD 2018-10-18  Thurs

DIM SHARED Cols AS INTEGER, Rows AS INTEGER, Nwords AS INTEGER, Spacer AS INTEGER 'Spacer is for Cols <= 20
REDIM SHARED L$(1 TO 1, 1 TO 1) ' for the letters grid these arrays need to be base 1
REDIM SHARED W$(1 TO 1) '         for the Words to find list.

' directions starting due East = 1 clockwise to NE = 8
DIM SHARED DX(1 TO 8) AS INTEGER, DY(1 TO 8) AS INTEGER
DX(1) = 1: DY(1) = 0 '   E
DX(2) = 1: DY(2) = 1 '   SE
DX(3) = 0: DY(3) = 1 '   S
DX(4) = -1: DY(4) = 1 '  SW
DX(5) = -1: DY(5) = 0 '  W
DX(6) = -1: DY(6) = -1 ' NW
DX(7) = 0: DY(7) = -1 '  N
DX(8) = 1: DY(8) = -1 '  NE

'main code varaibles
DIM i AS INTEGER, wate$, nFound AS INTEGER, k$

' Main code
LoadLetters 'reads baseName$ + "Letters.txt" file determines SHARED Rows, Cols for L$() array the letters block.
ShowPuzzle ' display L$() Puzzle with some row and column labels
LoadWords '  gets the list of words to search (up to 48) and sets the SHARED count, Nwords

'now to setup the 4 string arrays
DIM SHARED ew$(1 TO Rows), sn$(1 TO Cols), nesw$(1 TO Rows + Cols - 1), senw$(1 TO Rows + Cols - 1)
SetUp4Arrays

FOR i = 1 TO Nwords 'this time through find word, show word, display count found
    LOCATE 23, 1: PRINT SPACE$(40)
    LOCATE 23: PRINT W$(i);: INPUT "  press enter to show "; wate$

    '!!!!! This code tests 2 methods of finding the Search Word comment out the one not to be tested !!!!!
    'nFound = showWord%(W$(i)) 'first method, easy to code
    nFound = showWord2%(W$(i)) 'second method that creates 4 arrays of strings to test forward and reverse

    IF nFound THEN
        IF i > 24 THEN
            LOCATE i - 24, 62
        ELSE
            LOCATE i, 45
        END IF
        PRINT W$(i); nFound;
    END IF
NEXT
k$ = INKEY$ 'in case still pressing enter
WHILE LEN(k$): k$ = INKEY$: WEND
LOCATE 23, 1: PRINT SPACE$(40)
LOCATE 23, 1: PRINT "Word Search Finished"
_DELAY 1

FUNCTION showWord% (find$)
    'First find a letter that matches the first letter in find$,
    'then at that x, y try each of 8 directions to see if find a match.

    DIM first$, x AS INTEGER, y AS INTEGER, d AS INTEGER, b1 AS INTEGER, b2 AS INTEGER
    DIM xx AS INTEGER, yy AS INTEGER, b$, i AS INTEGER, wCount AS INTEGER, wate$
    first$ = MID$(find$, 1, 1)
    FOR y = 1 TO Rows
        FOR x = 1 TO Cols
            IF L$(x, y) = first$ THEN
                FOR d = 1 TO 8 'will word fit in this direction? 2 Booleans b1, b2 to test
                    b1 = (LEN(find$) - 1) * DX(d) + x > 0 AND (LEN(find$) - 1) * DX(d) + x <= Cols
                    b2 = (LEN(find$) - 1) * DY(d) + y > 0 AND (LEN(find$) - 1) * DY(d) + y <= Rows
                    IF b1 AND b2 THEN 'word fits,
                        ' build word from Letters block to see if matches word to find
                        b$ = first$: xx = x + DX(d): yy = y + DY(d)
                        FOR i = 2 TO LEN(find$)
                            b$ = b$ + L$(xx, yy)
                            xx = xx + DX(d): yy = yy + DY(d)
                        NEXT
                        xx = x: yy = y 'copy x, y for rebuilding word on screen
                        IF b$ = find$ THEN 'found one show our result
                            ClearPuzzle
                            FOR i = 1 TO LEN(find$)
                                LOCATE yy + 2, Spacer * xx + 3: PRINT L$(xx, yy);
                                xx = xx + DX(d): yy = yy + DY(d)
                            NEXT
                            wCount = wCount + 1
                            LOCATE 24, 1: PRINT trm$(wCount); "# @("; trm$(x); ", "; trm$(y); ")  >>> "; trm$(d); " direction";
                            LOCATE 23, 1: PRINT SPACE$(40)
                            LOCATE 23, 1: PRINT find$;
                            INPUT "  OK, press enter "; wate$
                            LOCATE 24, 1: PRINT SPACE$(40);
                            ShowPuzzle
                        END IF
                    END IF
                NEXT
            END IF
        NEXT
    NEXT
    showWord% = wCount
END FUNCTION

FUNCTION showWord2% (find$)
    'search the 4 arrays for word both forward and reverse
    'the ew$() array
    DIM i AS INTEGER, posi AS INTEGER, x AS INTEGER, y AS INTEGER, count AS INTEGER, d AS INTEGER, j AS INTEGER, wate$
    DIM fx AS INTEGER, fy AS INTEGER
    FOR i = 1 TO Rows
        posi = INSTR(ew$(i), find$)
        WHILE posi
            x = posi: y = i: fx = x: fy = y: d = 1
            GOSUB showWord
            posi = INSTR(posi + 1, ew$(i), find$)
        WEND
    NEXT
    FOR i = 1 TO Rows + Cols - 1
        posi = INSTR(senw$(i), find$)
        WHILE posi
            sePos i, posi, x, y: fx = x: fy = y: d = 2
            GOSUB showWord
            posi = INSTR(posi + 1, senw$(i), find$)
        WEND
    NEXT
    FOR i = 1 TO Cols
        posi = INSTR(sn$(i), find$)
        WHILE posi
            x = i: y = posi: fx = x: fy = y: d = 3
            GOSUB showWord
            posi = INSTR(posi + 1, sn$(i), find$)
        WEND
    NEXT
    FOR i = 1 TO Rows + Cols - 1
        posi = INSTR(Reverse$(nesw$(i)), find$)
        WHILE posi
            swPos i, posi, x, y: fx = x: fy = y: d = 4
            GOSUB showWord
            posi = INSTR(posi + 1, Reverse$(nesw$(i)), find$)
        WEND
    NEXT
    FOR i = 1 TO Rows
        posi = INSTR(Reverse$(ew$(i)), find$)
        WHILE posi
            x = Cols + 1 - posi: y = i: fx = x: fy = y: d = 5
            GOSUB showWord
            posi = INSTR(posi + 1, Reverse$(ew$(i)), find$)
        WEND
    NEXT
    FOR i = 1 TO Rows + Cols - 1
        posi = INSTR(Reverse$(senw$(i)), find$)
        WHILE posi
            nwPos i, posi, x, y: fx = x: fy = y: d = 6
            GOSUB showWord
            posi = INSTR(posi + 1, Reverse$(senw$(i)), find$)
        WEND
    NEXT
    FOR i = 1 TO Cols
        posi = INSTR(Reverse$(sn$(i)), find$)
        WHILE posi
            x = i: y = Rows - posi + 1: fx = x: fy = y: d = 7
            GOSUB showWord
            posi = INSTR(posi + 1, Reverse$(sn$(i)), find$)
        WEND
    NEXT
    FOR i = 1 TO Rows + Cols - 1
        posi = INSTR(nesw$(i), find$)
        WHILE posi
            nePos i, posi, x, y: fx = x: fy = y: d = 8
            GOSUB showWord
            posi = INSTR(posi + 1, nesw$(i), find$)
        WEND
    NEXT
    showWord2% = count
    EXIT FUNCTION

    showWord:
    ClearPuzzle
    FOR j = 1 TO LEN(find$)
        LOCATE y + 2, Spacer * x + 3: PRINT L$(x, y);
        x = x + DX(d): y = y + DY(d)
    NEXT
    count = count + 1
    LOCATE 24, 1: PRINT trm$(count); "# @("; trm$(fx); ", "; trm$(fy); ")  >>> "; trm$(d); " direction";
    LOCATE 23, 1: PRINT SPACE$(40)
    LOCATE 23, 1: PRINT find$;
    INPUT "  OK, press enter "; wate$
    LOCATE 24, 1: PRINT SPACE$(40);
    ShowPuzzle
    RETURN
END FUNCTION

SUB ShowPuzzle
    DIM x AS INTEGER, y AS INTEGER, wate$
    FOR y = 1 TO Rows
        FOR x = 1 TO Cols
            LOCATE y + 2, Spacer * x + 3: PRINT L$(x, y);
        NEXT
        PRINT
    NEXT
    'row and col # labels
    FOR y = 1 TO Rows: LOCATE y + 2, 1: PRINT RIGHT$(STR$(y), 2): NEXT
    FOR x = 1 TO Cols: LOCATE 1, Spacer * x + 3: PRINT RIGHT$(STR$(x), 1);: NEXT
END SUB

SUB ClearPuzzle
    DIM y AS INTEGER
    FOR y = 1 TO Rows: LOCATE y + 2, 4: PRINT SPACE$(Spacer * Cols): NEXT
END SUB

'===================================================================================================================

' subs for locating x, y in L$() given i row of string and INSTR Pos in one of 2 diagonal arrays forward and reverse
'the strings from the diagonals are particularly tricky translating back to the L$() the x, y letter position

' direction 8 NE the INTRpos is from reverse strings of iRow
SUB nePos (iRow AS INTEGER, INSTRpos AS INTEGER, xPos AS INTEGER, yPos AS INTEGER)
    DIM x AS INTEGER, y AS INTEGER
    IF iRow > Rows THEN
        x = iRow - Rows + 1: y = Rows
    ELSE
        x = 1: y = iRow
    END IF
    xPos = x + (INSTRpos - 1) * DX(8)
    yPos = y + (INSTRpos - 1) * DY(8)
END SUB

' direction 4 SW, the reverse strings of nesw$()
SUB swPos (iRow AS INTEGER, INSTRpos AS INTEGER, xPos AS INTEGER, yPos AS INTEGER)
    DIM x AS INTEGER, y AS INTEGER
    IF iRow > Cols THEN
        x = Cols: y = iRow - Cols + 1
    ELSE
        x = iRow: y = 1
    END IF
    xPos = x + (INSTRpos - 1) * DX(4)
    yPos = y + (INSTRpos - 1) * DY(4)
END SUB

' direction 2 SE the INTRpos is from reverse strings of iRow
SUB sePos (iRow AS INTEGER, INSTRpos AS INTEGER, xPos AS INTEGER, yPos AS INTEGER)
    DIM x AS INTEGER, y AS INTEGER
    IF iRow > Rows THEN
        x = iRow - Rows + 1: y = 1
    ELSE
        x = 1: y = iRow
    END IF
    xPos = x + (INSTRpos - 1) * DX(2)
    yPos = y + (INSTRpos - 1) * DY(2)
END SUB

' direction 6 NW, the reverse strings of nesw$()
SUB nwPos (iRow AS INTEGER, INSTRpos AS INTEGER, xPos AS INTEGER, yPos AS INTEGER)
    DIM x AS INTEGER, y AS INTEGER
    IF iRow > Cols THEN
        x = Cols: y = Rows - (iRow - Rows)
    ELSE
        x = Cols + 1 - iRow: y = Rows
    END IF
    xPos = x + (INSTRpos - 1) * DX(6)
    yPos = y + (INSTRpos - 1) * DY(6)
END SUB

' ======================================================================= end subs for helping find x, y in L$()

SUB SetUp4Arrays

    'create 4 arrays of string for scanning with INSTR

    DIM r AS INTEGER, c AS INTEGER, b$, x AS INTEGER, y AS INTEGER
    DIM i AS INTEGER, wate$ 'debugging

    ' for directions 1 E and reversing 5 W, load ew$ array
    FOR r = 1 TO Rows
        b$ = ""
        FOR c = 1 TO Cols
            b$ = b$ + L$(c, r)
        NEXT
        ew$(r) = b$
    NEXT
    'check
    'FOR i = 1 TO Rows
    '    PRINT ew$(i)
    'NEXT
    'INPUT "ew$() array, OK press enter "; wate$
    'CLS

    ' for directions 3 S and reversing 7 N, load sn$ array
    FOR c = 1 TO Cols
        b$ = ""
        FOR r = 1 TO Rows
            b$ = b$ + L$(c, r)
        NEXT
        sn$(c) = b$
    NEXT
    'check
    'FOR i = 1 TO Cols
    '    PRINT sn$(i)
    'NEXT
    'INPUT "sn$() array, OK press enter "; wate$
    'CLS

    ' for directions 8 NE and reversing 4 SW
    ' load nesw$ array with strings produced concatenating letters going up and right in L$ array
    FOR r = 1 TO Rows
        x = 1: y = r: b$ = ""
        WHILE x <= Cols AND y >= 1
            b$ = b$ + L$(x, y)
            x = x + 1: y = y - 1
        WEND
        nesw$(r) = b$
    NEXT
    FOR c = 2 TO Cols
        x = c: y = Rows: b$ = ""
        WHILE x <= Cols AND y >= 1
            b$ = b$ + L$(x, y)
            x = x + 1: y = y - 1
        WEND
        nesw$(Rows + c - 1) = b$
    NEXT
    'check
    'FOR i = 1 TO Rows + Cols - 1
    '    PRINT nesw$(i)
    'NEXT
    'INPUT "nesw$() array, OK press enter "; wate$
    'CLS

    ' for directions 2 SE and reversing 6 NW
    ' load senw$ array with strings produced concatenating letters going up and right in L$ array
    FOR r = 1 TO Rows
        x = 1: y = r: b$ = ""
        WHILE x <= Cols AND y <= Rows
            b$ = b$ + L$(x, y)
            x = x + 1: y = y + 1
        WEND
        senw$(r) = b$
    NEXT
    FOR c = 2 TO Cols
        x = c: y = 1: b$ = ""
        WHILE x <= Cols AND y <= Rows
            b$ = b$ + L$(x, y)
            x = x + 1: y = y + 1
        WEND
        senw$(Rows + c - 1) = b$
    NEXT
    'check
    'FOR i = 1 TO Rows + Cols - 1
    '    PRINT senw$(i)
    'NEXT
    'INPUT "senw$() array, OK press enter "; wate$
    'CLS
END SUB

SUB LoadWords
    'FileBaseName$ is shared and set at beginning of this code.
    'Nwords is Dim shared and set here.
    'This also displays the words on screen in up to 2 columns.
    'There is a 48 word limit to list for searching.
    'Also the words should not be more than 14 letters long.
    DIM fline$
    Nwords = 0
    IF _FILEEXISTS(FileBaseName$ + " Words.txt") THEN
        OPEN FileBaseName$ + " Words.txt" FOR INPUT AS #1
        DO UNTIL EOF(1)
            LINE INPUT #1, fline$
            IF LEN(LTRIM$(RTRIM$(fline$))) > 2 AND LEN(LTRIM$(RTRIM$(fline$))) < 15 THEN 'just skip short or long words
                Nwords = Nwords + 1
                IF Nwords > 48 THEN PRINT "Sorry, there are too many words to display, goodbye.": CLOSE #1: END
                REDIM _PRESERVE W$(1 TO Nwords)
                W$(Nwords) = fline$
                IF Nwords > 24 THEN
                    LOCATE Nwords - 24, 62
                ELSE
                    LOCATE Nwords, 45
                END IF
                PRINT W$(Nwords);
            END IF
        LOOP
        CLOSE #1
    ELSE
        PRINT "Sorry, can not find " + FileBaseName$ + " Words.txt, goodbye."
        END
    END IF
END SUB

SUB LoadLetters
    ' FileBaseName$ is shared and set at beginning of this code.
    ' DIM Shared Rows and Cols is set here for the rest of the app.
    ' There is a 40 column limit to letters across < 20 offers a space (Spacer) between them.
    ' There is a 20 line limit to the Letters block so that all filts in default screen.
    DIM fline$, i AS INTEGER
    IF _FILEEXISTS(FileBaseName$ + " Letters.txt") THEN
        OPEN FileBaseName$ + " Letters.txt" FOR INPUT AS #1
        DO UNTIL EOF(1)
            Rows = Rows + 1
            IF Rows > 20 THEN PRINT "Sorry, there is a 20 row limit to the Letters block, goodbye.": CLOSE #1: END
            LINE INPUT #1, fline$
            IF Rows = 1 THEN
                Cols = LEN(fline$)
                IF Cols > 20 THEN Spacer = 1 ELSE Spacer = 2
                IF Cols > 40 THEN PRINT "Sorry, the Letters block is too wide, goodbye.": CLOSE #1: END
            END IF
            REDIM _PRESERVE L$(1 TO Cols, 1 TO Rows)
            FOR i = 1 TO Cols
                L$(i, Rows) = MID$(fline$, i, 1)
            NEXT
        LOOP
        CLOSE #1
    ELSE
        PRINT "Sorry, can not find " + FileBaseName$ + " Letters.txt, goodbye."
        END
    END IF
END SUB

FUNCTION Reverse$ (s$) 'reverse the letters in a string
    DIM i AS INTEGER, b$
    IF LEN(s$) <= 1 THEN Reverse$ = s$: EXIT FUNCTION
    FOR i = 1 TO LEN(s$)
        b$ = MID$(s$, i, 1) + b$
    NEXT
    Reverse$ = b$
END FUNCTION

FUNCTION trm$ (n AS INTEGER) 'str$ and trim$ a number
    trm$ = RIGHT$(" " + LTRIM$(RTRIM$(STR$(n))), 2)
END FUNCTION
